function y = NadarayaWatson(x,y,X,Y,Z,hK,hT)

% Bivariate Gaussian Kernel
Kernel = @(u) exp(-u.*u./2);

% Calculate the weights and their sum
w = Kernel((x-X)./hK) .* Kernel((y-Y)./hT) ;
W = sum(w);

% Return IV kernel at inputs (K,T)
y = dot(w,Z)/ W;
