clc; clear;

% Generate the perturbed "peaks" function
N = 50;
Z = peaks(N) + rand(N).*2;
[X,Y] = meshgrid(1:N);

% Vectorize the grid
x = X(:);
y = Y(:);
z = Z(:);

% Choice of smoothing parameters
h = 2.0;

% Vector of N-W implied vols
for k=1:length(x)
    vec(k) = NadarayaWatson(x(k),y(k),x,y,z,h,h);
end

% Convert to surface
Zi = zeros(N,N);
Zi(:) = vec';

% Surface of the result
subplot(1,2,1)
surf(Z)
subplot(1,2,2)
surf(Zi)

